#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/architecture.mk

# Package names
PKG_driver      := libhybris

# Strong needs at least gcc 4.9
export DEB_BUILD_MAINT_OPTIONS=hardening=-stackprotectorstrong

ifneq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
	CC :=$(DEB_HOST_GNU_TYPE)-$(CC)
	CXX :=$(DEB_HOST_GNU_TYPE)-$(CXX)
endif

# Priority of the alternatives
alt_priority    := 400

# Directory naming schemes
PKG_dirname             := $(PKG_driver)-egl
bindir                  := usr/bin
datadir                 := usr/share
libdir                  := usr/lib/$(DEB_HOST_MULTIARCH)
includedir              := usr/include
sysconfdir              := etc
PKG_libdir              := $(libdir)/$(PKG_dirname)
PKG_configdir           := $(PKG_libdir)
ld_so_conf_dir          := $(PKG_configdir)
ld_so_conf_file         := ld.so.conf
alt_ld_so_conf_file     := alt_ld.so.conf
ld_so_conf_path         := $(ld_so_conf_dir)/$(ld_so_conf_file)
alt_ld_so_conf_path     := $(ld_so_conf_dir)/$(alt_ld_so_conf_file)

ANDROID_HEADERS_PATH = /usr/include/android
DEFAULT_CONFIGURATION = \
	--enable-wayland \
	--with-android-headers=$(ANDROID_HEADERS_PATH) \
	--enable-property-cache \
	--enable-experimental \
	--with-default-egl-platform=wayland
ARCH_CONFIGURATION =

ifeq ($(DEB_HOST_ARCH),$(findstring $(DEB_HOST_ARCH), armhf))
ARCH_CONFIGURATION = \
	--enable-arch=arm \
	--enable-mali-quirks \
	--enable-adreno-quirks
endif
ifeq ($(DEB_HOST_ARCH),$(findstring $(DEB_HOST_ARCH), arm64))
ARCH_CONFIGURATION = \
	--enable-arch=arm64 \
	--enable-mali-quirks \
	--enable-adreno-quirks
endif
ifeq ($(DEB_HOST_ARCH),$(findstring $(DEB_HOST_ARCH), i386))
ARCH_CONFIGURATION = \
	--enable-arch=x86
endif
ifeq ($(DEB_HOST_ARCH),$(findstring $(DEB_HOST_ARCH), amd64))
ARCH_CONFIGURATION = \
	--enable-arch=x86
endif

override_dh_auto_configure:
	dh_auto_configure --sourcedirectory=hybris -- \
		$(DEFAULT_CONFIGURATION) \
		$(ARCH_CONFIGURATION)

override_dh_install:
	# Fill in important variables
	for i in $(PKG_driver).dirs \
			$(PKG_driver).install \
			$(PKG_driver).links \
			$(PKG_driver).postinst \
			$(PKG_driver).postrm \
			$(PKG_driver).prerm; do \
		sed -e "s|#LIBDIR#|$(libdir)|g" \
			-e "s|#BINDIR#|$(bindir)|g" \
			-e "s|#SYSCONFDIR#|$(sysconfdir)|g" \
			-e "s|#LDSOCONF#|$(ld_so_conf_path)|g" \
			-e "s|#ALTLDSOCONF#|$(alt_ld_so_conf_path)|g" \
			-e "s|#ALTPRIORITY#|$(alt_priority)|g" \
			-e "s|#DATADIR#|$(datadir)|g" \
			-e "s|#PKGCONFIGDIR#|$(PKG_configdir)|g" \
			-e "s|#PKGLIBDIR#|$(PKG_libdir)|g" \
			-e "s|#DRIVERNAME#|$(PKG_driver)|g" \
			-e "s|#DRIVERSRCNAME#|$(DEB_SOURCE)|g" \
			-e "s|#VERSION#|$(DEB_VERSION)|g" \
			-e "s|#INCLUDEDIR#|$(includedir)|g" \
			-e "s|#DEB_HOST_MULTIARCH#|$(DEB_HOST_MULTIARCH)|g" \
			debian/$$i.in > debian/$$i; \
	done

	dh_install

	# ld.so.conf
	echo "/$(PKG_libdir)" > "$(CURDIR)/debian/$(PKG_driver)/$(ld_so_conf_path)"

	# empty ld.so.conf for the fake multi-arch alternative
	echo "" > "$(CURDIR)/debian/$(PKG_driver)/$(alt_ld_so_conf_path)"

override_dh_shlibdeps:
	dh_shlibdeps -l"$(CURDIR)/debian/$(PKG_driver)/$(PKG_libdir)"

%:
	dh $@ --with autoreconf --sourcedirectory=hybris
